#ifndef __SBL_SUPPORT_H__
#define __SBL_SUPPORT_H__

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>
#include <stdarg.h>
#ifdef WIN32
#include <windows.h>
#include <direct.h>
#endif
#include "vmmc.h"

#define UNEXPORT_NOT_IMPLEMENTED
#define UNIMPORT_NOT_IMPLEMENTED

typedef int BOOL;
typedef volatile int32 *PMyriBuffer;

#ifdef __cplusplus
extern "C" {
#endif

extern BOOL IsSlave(void);
extern BOOL IsMaster(void);
extern void *PageAlignedMalloc(unsigned pages);
extern BOOL PageAlignedFree(void *buf);
extern void *NonOverlapMalloc(unsigned pages);
extern BOOL NonOverlapFree(void *buf);
extern void *SafeMalloc(unsigned size, const char *err_format, ...);

extern void CheckSlaveArg(unsigned *argc, char **argv);
extern BOOL SpawnSlavesOnly(unsigned slaves, unsigned argc, char **argv);
extern BOOL SpawnSlaves(unsigned slaves, unsigned argc, char **argv);
extern vmmc_node_t GetNode(unsigned index);
extern vmmc_pid_t GetSquid(unsigned index);
extern unsigned GetMyProcIndex(void);
extern unsigned TotalProcs(void); 
extern BOOL IsProc(unsigned index);

#ifdef __cplusplus
}
#endif

#endif
