#ifndef __SPMD_COMM_H__
#define __SPMD_COMM_H__

#include "timing.h"
#include "sbl_support.h"

/* 
 * TTransfer is a struct for data transfer,
 * sender uses sender_buffer, sender_proxy_buffer and buffer_size
 * recver uses recver_buffer, buffer_size, expected_value to poll the last word
 * and than restore the value to init_value.
 */
typedef struct _TTransfer *PTransfer;
extern PTransfer INVALID_TRANSFER;

#ifdef __cplusplus
extern "C" {
#endif

extern PTransfer RegisterTransfer(unsigned sender_index, void *sender_buffer,
			   unsigned receiver_index, void *receiver_buffer,
			   unsigned buffer_size, unsigned transfer_id, 
			   int32 init_value);

extern void DoTransfer(PTransfer t, int32 expected_value, int32 new_init_value, 
		       unsigned recv_timeout);


extern void DoTransferSend(PTransfer t, int32 expected_value, 
			   unsigned send_timeout);
extern void DoTransferReceive(PTransfer t, int32 expected_value, 
			      int32 new_init_value, unsigned recv_timeout);

extern void DoTransferGet(PTransfer t, unsigned send_timeout);

extern void DoTransferChange(PTransfer t, int32 init_value, unsigned recv_timeout);

extern void MonitorWord(PTransfer t, unsigned index, int32 expected_value, unsigned timeout);

#ifdef __cplusplus
}
#endif

#endif
