#ifndef __TIMING_H_
#define __TIMING_H_
#include <stdio.h>

#ifdef WIN32
#include <windows.h>
typedef DWORDLONG Cycle;
typedef LONGLONG SCycle;
#else
typedef unsigned long long Cycle;
typedef long long SCycle;
#endif

#if (!defined(WIN32) && !defined(__STRICT_ANSI__))
#define GETCYCLE(t) asm volatile (".byte 0x0f, 0x31" : "=A" (t))
#else
#define GETCYCLE(t) (t=GetCycle())
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern void TimingInit(void);
extern unsigned GetCPUClock(void);

extern Cycle GetCycle(void);
extern float Interval(Cycle start, Cycle end);
extern float mInterval(Cycle start, Cycle end);
extern float uInterval(Cycle start, Cycle end);
extern float Period(Cycle c);
extern float mPeriod(Cycle c);
extern float uPeriod(Cycle c);

#ifdef __cplusplus
}
#endif

#endif
