#ifndef __VMMCERROR_H__
#define __VMMCERROR_H__

/* this file is the only file shared by all parts of system */

#define INVALID_BUF_SPACE 0
#define INTRANSIT_BUF_SPACE 1
#define GLOBAL_BUF_SPACE 2
#define FIRST_VALID_BUF_SPACE GLOBAL_BUF_SPACE

typedef enum {
    vmmc_Success = 0,

    /* special return codes */
    vmmcErr_NoParent,

    /* --------- user-accessible error codes start here ----------*/
    vmmcErr_NoSuchError = -256,   /* valid errors are > vmmcErr_NoSuchError */
    vmmcErr_NoMem,                /* - 255 */
    vmmcErr_NoSuchNode,           /* - 254 */
    vmmcErr_NoSuchProcess,
    vmmcErr_NoPhysDestSpace,
    vmmcErr_NoVirtDestSpace,
    vmmcErr_BadProxyExtension,    /* - 250 */
    vmmcErr_Sending,
    vmmcErr_OverlappedBufs,
    vmmcErr_BadRbufState,
    vmmcErr_BadIbufState,
    vmmcErr_BadAlignment,
    vmmcErr_BadSize,
    vmmcErr_BadProxyAddr,
    vmmcErr_BlockedNotifications,
    vmmcErr_UnblockedNotifications,
    vmmcErr_NotInHandler,         /* - 240 */
    vmmcErr_BadArg,
    vmmcErr_NotImplemented,
    vmmcErr_InProgress,           /* - 237 */
    vmmcErr_BadAsyncHandle,


    /* following are errors used by VMMC internally */
    vmmcErr_NoSuchDevice,
    vmmcErr_BadDevice,
    vmmcErr_BadClient,
    vmmcErr_BadChannel,
    vmmcErr_BufferTooLarge,
    vmmcErr_OutOfChannels,        /* - 230 */
    vmmcErr_BadUTLBIndex,
    vmmcErr_BadNPages,
    vmmcErr_BadAddress,
    vmmcErr_DuplicateVI,
    vmmcErr_InsufficientResources,
    vmmcErr_AlreadyInitialized
} vmmc_result_t;

#endif
